=== debian/changelog ===
trace-cmd (2.9.1-1) unstable; urgency=medium

  * Update to upstream v2.9.1
    - New version has updated manpages. (LP: #1868900)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 19 Aug 2020 20:51:17 +0100
