=== debian/watch ===
version=4
https://git.kernel.org/pub/scm/utils/trace-cmd/trace-cmd.git /pub/scm/utils/trace-cmd/trace-cmd.git/snapshot/trace-cmd-v?(\d\S+)\.tar\.gz
